<?php

namespace eluhr\flysystemRestApi;

use dmstr\web\traits\AccessBehaviorTrait;
use eluhr\flysystemRestApi\interfaces\FileStorageComponentInterface;
use yii\di\Instance;

class Module extends \yii\base\Module
{
    use AccessBehaviorTrait;

    /**
     * component id of the file storage component
     *
     * @var string
     */
    public $fileStorage = 'fileStorage';

    /**
     * @inheritdoc
     */
    public function init()
    {
        parent::init();

        // Ensure, that file storage component is instance of needed component interface
        Instance::ensure($this->fileStorage, FileStorageComponentInterface::class);
    }
}
