<?php

namespace eluhr\flysystemRestApi\controllers;

use eluhr\flysystemRestApi\interfaces\FileStorageComponentInterface;
use eluhr\flysystemRestApi\Module;
use Yii;
use yii\base\InvalidConfigException;
use yii\rest\Controller;

/**
 * @property Module $module
 */
abstract class BaseController extends Controller
{

    /**
     * @inheritdoc
    */
    public function behaviors()
    {
        $behaviors = parent::behaviors();
        unset($behaviors['contentNegotiator']['formats']['application/xml']); // TODO: Remove? Do we want/need xml?
        return $behaviors;
    }


    /**
     * @throws InvalidConfigException
     */
    public function getFileStorage(): FileStorageComponentInterface
    {
        return Yii::$app->get($this->module->fileStorage);
    }

}
