<?php

namespace eluhr\flysystemRestApi\interfaces;

use eluhr\flysystemRestApi\models\StorageItem;

interface PluginInterface
{

    /**
     * Name of the plugin. Must be alphanumeric without special characters and spaces
     *
     * @return string
     */
    public function name(): string;

    /**
     * Add plugin to the owner. Return true/false on success/fail
     *
     * @param StorageItem $owner
     *
     * @return bool
     */
    public function apply(StorageItem $owner): bool;
}
