<?php

use yii\db\Migration;

/**
 * Handles the creation of table `{{%storage_item_permission}}`.
 */
class m230413_130201_create_storage_item_permission_table extends Migration
{
    /**
     * {@inheritdoc}
     */
    public function up()
    {
        $this->createTable('{{%storage_item_permission}}', [
            'id' => $this->string(36)->append('PRIMARY KEY')->notNull(),
            'storage_item_id' => $this->string(36)->notNull()->unique(),
            'access_owner' => $this->string(255)->notNull(),
            'access_read' => $this->string(255)->notNull(),
            'access_update' => $this->string(255)->notNull(),
            'access_delete' => $this->string(255)->notNull(),
            'access_domain' => $this->string(255)->notNull(),
            'created_at' => $this->dateTime(),
            'updated_at' => $this->dateTime()
        ], $this->db->driverName === 'mysql' ? 'CHARACTER SET utf8 COLLATE utf8_unicode_ci ENGINE=InnoDB' : null);
        $this->addForeignKey('fk_storage_item_permissions_0', '{{%storage_item_permission}}', 'storage_item_id', '{{%storage_item}}', 'id', 'CASCADE', 'CASCADE');
    }

    /**
     * {@inheritdoc}
     */
    public function down()
    {
        $this->dropTable('{{%storage_item_permission}}');
    }
}
