<?php

namespace eluhr\flysystemRestApi\models;

use eluhr\flysystemRestApi\interfaces\FileStorageComponentInterface;
use yii\base\Model;

abstract class FileStorageModel extends Model
{
    private FileStorageComponentInterface $_fileStorage;

    /**
     * @inheritdoc
     */
    public function formName()
    {
        // Load directly without model name scope
        return '';
    }

    /**
     * @return FileStorageComponentInterface
     */
    public function getFileStorage(): FileStorageComponentInterface
    {
        return $this->_fileStorage;
    }

    /**
     * @param FileStorageComponentInterface $fileStorage
     */
    public function setFileStorage(FileStorageComponentInterface $fileStorage): void
    {
        $this->_fileStorage = $fileStorage;
    }

    /**
     * @inheritdoc
    */
    public function rules()
    {
        $rules = parent::rules();
        $rules[] = [
            [
                'basePath'
            ],
            'filter',
            'filter' => function (mixed $value) {
                if (is_string($value)) {
                    return trim($value, DIRECTORY_SEPARATOR);
                }
                return $value;
            }
        ];
        return $rules;
    }

    /**
     * Response for api controller
     */
    abstract public function getResponse(): array;

}
