<?php

namespace eluhr\flysystemRestApi\models\plugins;

use DateTimeImmutable;
use Ramsey\Uuid\Uuid;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;

abstract class BasePluginModel extends ActiveRecord
{

    /**
     * @inheritdoc
     */
    public function beforeSave($insert)
    {
        // Generate new uuid if not set
        if ($insert && empty($this->id)) {
            $this->setAttribute('id', Uuid::uuid4()->toString());
        }
        return parent::beforeSave($insert);
    }


    /**
     * @inheritdoc
     */
    public function behaviors()
    {
        $behaviors = parent::behaviors();
        $behaviors['timestamp'] = [
            'class' => TimestampBehavior::class,
            'value' => (new DateTimeImmutable())->format('Y-m-d H:i:s')
        ];
        return $behaviors;
    }
}
