<?php

namespace eluhr\flysystemRestApi\models\plugins;

use DateTimeImmutable;
use Ramsey\Uuid\Uuid;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;

/**
 * @property string $id
 * @property string $storage_item_id
 * @property string $name
 */
class StorageItemAlias extends BasePluginModel
{
    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return '{{%storage_item_alias}}';
    }


    /**
     * @inheritdoc
     */
    public function rules()
    {
        $rules = parent::rules();
        $rules[] = [
            [
                'storage_item_id',
                'name'
            ],
            'required'
        ];
        $rules[] = [
            'name',
            'string',
            'max' => 255
        ];
        $rules[] = [
            'storage_item_id',
            'unique'
        ];
        return $rules;
    }
}
