<?php

namespace eluhr\flysystemRestApi\models\plugins;

use DateTimeImmutable;
use Ramsey\Uuid\Uuid;
use yii\behaviors\TimestampBehavior;
use yii\db\ActiveRecord;

/**
 * @property string $id
 * @property string $storage_item_id
 * @property string $access_owner
 * @property string $access_read
 * @property string $access_update
 * @property string $access_delete
 * @property string $access_domain
 */
class StorageItemPermission extends BasePluginModel
{

    /**
     * @inheritdoc
     */
    public static function tableName()
    {
        return '{{%storage_item_permission}}';
    }

    /**
     * @inheritdoc
     */
    public function rules()
    {
        $rules = parent::rules();
        $rules[] = [
            [
                'storage_item_id',
                'access_owner',
                'access_read',
                'access_update',
                'access_delete',
                'access_domain'
            ],
            'required'
        ];
        $rules[] = [
            [
                'access_owner',
                'access_read',
                'access_update',
                'access_delete',
                'access_domain'
            ],
            'string',
            'max' => 255
        ];
        $rules[] = [
            'storage_item_id',
            'unique'
        ];
        return $rules;
    }
}
