<?php

namespace eluhr\flysystemRestApi\plugins;

use eluhr\flysystemRestApi\interfaces\PluginInterface;
use eluhr\flysystemRestApi\models\plugins\StorageItemAlias;
use eluhr\flysystemRestApi\models\plugins\StorageItemCategory;
use eluhr\flysystemRestApi\models\StorageItem;

class AliasPlugin implements PluginInterface
{
    /**
     * @param StorageItem $owner
     *
     * @inheritdoc
     */
    public function apply(StorageItem $owner): bool
    {
        /** @var StorageItemAlias $permission */
        $alias = StorageItemAlias::find()->andWhere(['storage_item_id' => $owner->id])->one();

//        $owner->setLabel($alias->name ?? $owner->getLabel());
        $owner->addExtraMetaData($this->name(), [
            'original' => $owner->name,
            'alias' => $alias->name ?? null
        ]);

        return true;
    }

    public function name(): string
    {
        return 'alias';
    }
}
