<?php

namespace eluhr\flysystemRestApi\plugins;

use eluhr\flysystemRestApi\interfaces\PluginInterface;
use eluhr\flysystemRestApi\models\plugins\StorageItemCategory;
use eluhr\flysystemRestApi\models\StorageItem;

class CategoryPlugin implements PluginInterface
{
    /**
     * @param StorageItem $owner
     *
     * @inheritdoc
     */
    public function apply(StorageItem $owner): bool
    {
        /** @var StorageItemCategory $permission */
        $category = StorageItemCategory::find()->andWhere(['storage_item_id' => $owner->id])->one();

        $owner->addExtraMetaData($this->name(), $category->name ?? null);

        return true;
    }

    public function name(): string
    {
        return 'category';
    }
}
