<?php

namespace eluhr\flysystemRestApi\plugins;

use eluhr\flysystemRestApi\interfaces\PluginInterface;
use eluhr\flysystemRestApi\models\StorageItem;

class FileExtensionPlugin implements PluginInterface
{
    /**
     * @param StorageItem $owner
     *
     * @inheritdoc
     */
    public function apply(StorageItem $owner): bool
    {
        $owner->addExtraMetaData($this->name(), [
            'extension' => $owner->isFile() ? pathinfo($owner->name, PATHINFO_EXTENSION) : ''
        ]);

        return true;
    }

    public function name(): string
    {
        return 'extension';
    }
}
