<?php

namespace eluhr\flysystemRestApi\plugins;

use eluhr\flysystemRestApi\interfaces\PluginInterface;
use eluhr\flysystemRestApi\models\plugins\StorageItemPermission;
use eluhr\flysystemRestApi\models\StorageItem;

class PermissionPlugin implements PluginInterface
{
    /**
     * @param StorageItem $owner
     *
     * @inheritdoc
     */
    public function apply(StorageItem $owner): bool
    {
        /** @var StorageItemPermission $permission */
        $permission = StorageItemPermission::find()->andWhere(['storage_item_id' => $owner->id])->one();

        $owner->addExtraMetaData($this->name(), [
            'domain' => $permission->access_domain ?? null,
            'read' => $permission->access_read ?? null,
            'update' => $permission->access_update ?? null,
            'delete' => $permission->access_delete ?? null,
            'owner' => $permission->access_owner ?? null
        ]);

        return true;
    }

    public function name(): string
    {
        return 'permissions';
    }
}
