<?php

namespace eluhr\flysystemRestApi\widgets;

use eluhr\flysystemRestApi\assets\FilemanagerAsset;
use yii\base\Widget;
use yii\helpers\Url;
use yii\web\View;

class Filemanager extends Widget
{

    public $pluginOptions = [];

    public $moduleId = 'storage';

    /**
     * @inheritdoc
     */
    public function init()
    {
        parent::init();

        $this->pluginOptions['urls']['list'] = $this->pluginOptions['urls']['list'] ?? Url::to(['/' . $this->moduleId . '/api/list', 'path' => '']);
        $this->pluginOptions['urls']['uploadFiles'] = $this->pluginOptions['urls']['uploadFiles'] ?? Url::to(['/' . $this->moduleId . '/api/upload-files']);
        $this->pluginOptions['urls']['createDirectory'] = $this->pluginOptions['urls']['createDirectory'] ?? Url::to(['/' . $this->moduleId . '/api/create-directory']);
        $this->pluginOptions['urls']['deleteDirectory'] = $this->pluginOptions['urls']['deleteDirectory'] ?? Url::to(['/' . $this->moduleId . '/api/delete-directory', 'id' => '']);
        $this->pluginOptions['urls']['deleteFile'] = $this->pluginOptions['urls']['deleteFile'] ?? Url::to(['/' . $this->moduleId . '/api/delete-file', 'id' => '']);

        $this->pluginOptions['plugins']['category']['urls']['updateCategory'] = $this->pluginOptions['plugins']['category']['urls']['updateCategory'] ?? Url::to(['/' . $this->moduleId . '/api/plugins/update-category']);
        $this->pluginOptions['plugins']['alias']['urls']['updateAlias'] = $this->pluginOptions['plugins']['alias']['urls']['updateAlias'] ?? Url::to(['/' . $this->moduleId . '/api/plugins/update-alias']);
    }

    /**
     * @inheritdoc
     */
    public function run()
    {
        $this->registerAssets();;
        return $this->render('filemanager');
    }

    /**
     * Register assets and create new filemanager instance
     */
    public function registerAssets()
    {
        FilemanagerAsset::register($this->view);
        $options = json_encode($this->pluginOptions, JSON_UNESCAPED_SLASHES | JSON_UNESCAPED_UNICODE);
        $this->view->registerJs('createFilemanager("' . $this->getId() . '", ' . $options . ')', View::POS_END);
    }
}
